/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.test.servlets;

import com.test.forms.NouveauPompierForm;
import java.io.IOException;
import java.io.PrintWriter;
import jakarta.servlet.ServletException;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import java.util.ArrayList;

/**
 *
 * @author Dominique_2
 */
public class NouveauServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        try ( PrintWriter out = response.getWriter()) {
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet NouveauServlet</title>");            
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet NouveauServlet at " + request.getContextPath() + "</h1>");
            out.println("</body>");
            out.println("</html>");
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        //processRequest(request, response);
        getServletContext().getRequestDispatcher("/WEB-INF/nouveauJSP.jsp").forward(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
       
        NouveauPompierForm nvf = new NouveauPompierForm();
        int idClient = nvf.verifNouveauClient(request);
        request.setAttribute("idClient", idClient);
        request.setAttribute("message", nvf.getMessage());
        if(idClient != -1) {
            //Ajout du no du client créé, dans une collection d'entiers stockée en session
            //1, Récupération de la session :
            HttpSession maSession = request.getSession();
            //2, Récupération de la collection des clients si elle existe, création sinon :
            ArrayList<Integer> lesNouveauxClients = (ArrayList<Integer>)
                maSession.getAttribute("lesNvxClients");
            if(lesNouveauxClients == null) {
                lesNouveauxClients = new ArrayList<>();
            }
            //3, Ajout du no du client créé dans la collection :
            lesNouveauxClients.add(idClient);
            //4, MAJ de la session
            maSession.setAttribute("lesNvxClients", lesNouveauxClients);
        }
        getServletContext().getRequestDispatcher("/WEB-INF/nouveauJSP.jsp").forward(request, response);
        HttpSession maSession = request.getSession();
//        String maChaine = null;
//        if(maSession.getAttribute("monAttribut" != null) {
//            String maChaine = (String) maSession.getAttribute("monAttribut");
//        }
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
